
import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class SimpleHoroServletWithRedirection extends HttpServlet {

  public void doPost(HttpServletRequest request, HttpServletResponse response)
      throws ServletException, IOException {

    // Get the sign.
    String sign = request.getParameter("sign").toLowerCase();

    // Check if redirection is necessary.
    if (sign.equals("joke")) {
      response.sendRedirect("http://www.comedycentral.com/jokes/index.jhtml");
      return;
    }

    // Check if status code should be sent, since this choice is
    // not implemented.
    if (sign.equals("dare")) {
      response.sendError(HttpServletResponse.SC_NOT_IMPLEMENTED,
          "Sorry. Please try another day!");
      return;
    }

    // Get the horoscope.
    String horoscopeReply = getHoroscope(sign);

    // Set any response headers
    response.setContentType("text/html");

    // Get a writer for the response.
    PrintWriter out = response.getWriter();

    // Create the response.
    out.println("<html><body><h1>Simple Horoscope (with Redirection)</h1>");

    out.println("<h3> Your horoscope, " + sign.toUpperCase() + ":</h3>");

    out.println("<h4>" + horoscopeReply + "</h4>");
    out.println("<h4>Good luck! You are going to need it.</h4>");
    out.println("</body></html>");

    // Flush and close the writer.
    out.flush();
    out.close();
  }

  public void doGet(HttpServletRequest request, HttpServletResponse response)
      throws ServletException, IOException {
    doPost(request, response);
  }

  private String getHoroscope(String sign) {
    return "If you think knowing your horoscope "
        + "is going to help you, you are gravely mistaken.";
  }
}