
import java.io.IOException;

import javax.servlet.ServletContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

public class RequestHandler extends HttpServlet {

  public void init() {
    // Set the company name in the servlet context.
    ServletContext context = getServletContext();
    context.setAttribute("companyName", "WeWillSellYouAnything.com");
  }

  public void doPost(HttpServletRequest request, HttpServletResponse response)
      throws IOException, ServletException {
    // Get the session (or create a new one).
    HttpSession session = request.getSession();

    // Read form parameters.
    String dataName = request.getParameter("dataname");
    String dataValue = request.getParameter("datavalue");
    String command = request.getParameter("submitCmd");

    /*
     * System.out.println("dataName: " + dataName);
     * System.out.println("dataValue: " + dataValue);
     * System.out.println("command: " + command);
     */

    // Logs the command parameter.
    log("command: " + command);

    String formLocation = "index.html";

    if (command == null)
      // Redirect to the HTML form.
      response.sendRedirect(formLocation);
    else if (command.startsWith("Add")) {
      if (!dataName.equals("") && !dataValue.equals("")) {
        // Add parameters to the session.
        session.setAttribute(dataName, dataValue);
        // Update grand total.
        updateGrandTotal();
      }
      // Redirect to the HTML form.
      response.sendRedirect(formLocation);
    } else if (command.startsWith("Show"))
      // Redirect to the ShowData servlet.
      response.sendRedirect("ShowData");
    else if (command.startsWith("Clear"))
      // Redirect to the ClearSession servlet.
      response.sendRedirect("ClearSession");
  }

  private void updateGrandTotal() {
    ServletContext context = getServletContext();
    synchronized (context) { // Drastic but thread-safe.
      String attributeName = "grandTotal";
      String attributeValue = (String) context.getAttribute(attributeName);
      if (attributeValue != null) {
        context.setAttribute(attributeName, String.valueOf(Integer
            .parseInt(attributeValue) + 1));
      } else
        context.setAttribute(attributeName, "1");
    }
  }

  public void doGet(HttpServletRequest request, HttpServletResponse response)
      throws IOException, ServletException {
    doPost(request, response);
  }

}