

import java.io.IOException;
import java.io.PrintWriter;
import java.util.Date;
import java.util.Enumeration;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

public class ServletUtil {

  public static void echoRequestMethodLineInfo(HttpServletRequest req,
      PrintWriter out) throws ServletException, IOException {

    out.print("<h3>Request Method- and Path-related" + " Information</h3>");
    out.print("<p>");
    out.print("Method: " + req.getMethod() + "<br>");
    out.print("Scheme: " + req.getScheme() + "<br>");
    out.print("Protocol: " + req.getProtocol() + "<br>");
    out.print("Requested URL: " + req.getRequestURL() + "<br>");
    out.print("Requested URI: " + req.getRequestURI() + "<br>");
    out.print("Servlet Path: " + req.getServletPath() + "<br>");
    out.print("Context Path: " + req.getContextPath() + "<br>");
    out.print("Query: " + req.getQueryString() + "<br>");
    out.print("Path info: " + req.getPathInfo() + "<br>");
    out.print("Path translated: " + req.getPathTranslated() + "<br>");
    out.println("</p>");
  }

  public static void echoRequestHeaders(HttpServletRequest req, PrintWriter out)
      throws ServletException, IOException {

    out.print("<h3>Request Header Information</h3>");
    out.print("<p>");
    Enumeration enumerator = req.getHeaderNames();
    while (enumerator.hasMoreElements()) {
      String header = (String) enumerator.nextElement();
      String value = req.getHeader(header);
      out.print(header + ": " + value + "<br>");
    }
    out.println("</p>");
  }

  public static void echoRequestParameters(HttpServletRequest req,
      PrintWriter out) throws ServletException, IOException {

    out.print("<h3>Request Parameters</h3>");
    out.print("<p>");
    Enumeration enumerator = req.getParameterNames();
    while (enumerator.hasMoreElements()) {
      String paramName = (String) enumerator.nextElement();
      String paramValue = req.getParameter(paramName);
      out.print(paramName + ": " + paramValue + "<br>");
    }
    out.println("</p>");
  }

  public static void echoInitParameters(ServletConfig config, PrintWriter out)
      throws ServletException, IOException {

    out.print("<h3>Initialization Parameters</h3>");
    out.print("<p>");
    Enumeration enumerator = config.getInitParameterNames();
    while (enumerator.hasMoreElements()) {
      String paramName = (String) enumerator.nextElement();
      String paramValue = config.getInitParameter(paramName);
      out.print(paramName + ": " + paramValue + "<br>");
    }
    out.println("</p>");
  }

  public static void echoSessionInfo(HttpSession session, PrintWriter out)
      throws ServletException, IOException {
    out.println("<h3>Session Information</h3>");
    out.println("<p>");
    out.println("Session ID: " + session.getId() + "<br/>");
    out.println("Whether the session is new: " + session.isNew() + "<br/>");
    out.println("Creation Time: " + new Date(session.getCreationTime())
        + "<br/>");
    out.println("When Last Accessed: "
        + new Date(session.getLastAccessedTime()) + "<br/>");
    out.println("</p>");
  }
}