
import java.io.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

public class ShowData extends HttpServlet {

  public void doPost(HttpServletRequest request, HttpServletResponse response)
      throws IOException, ServletException { // Set the content type.
    response.setContentType("text/html");

    // Get a writer for the response.
    PrintWriter out = response.getWriter();

    // Create the html content.
    out.println("<html>");
    out.println("<head>");
    String title = getCompanyName();
    out.println("<title>" + title + "</title>");
    out.println("</head>");
    out.println("<body>");
    out.println("<h3>" + title + "</h3>");

    // Echo misc. informaton.
    // ServletUtil.echoRequestMethodLineInfo(request, out);
    ServletUtil.echoRequestHeaders(request, out);

    // Get the session, if there is one.
    // Does not create one if there is none.
    HttpSession session = request.getSession(false);
    if (session != null) {
      ServletUtil.echoSessionInfo(session, out);

      // List data in the session.
      listSessionData(session, out);
    }

    // Send grand total
    sendGrandTotal(out);

    // Render the form.
    renderForm(response, out);

    out.println("</body>");
    out.println("</html>");
    out.flush();
    out.close();
  }

  private void listSessionData(HttpSession session, PrintWriter out)
      throws IOException, ServletException {
    int total = 0;
    Enumeration names = session.getAttributeNames();
    String attributes = "";
    while (names.hasMoreElements()) {
      String name = (String) names.nextElement();
      String value = session.getAttribute(name).toString();
      attributes += (name + ": " + value + "<br/>");
      total++;
    }
    if (total == 0)
      out.println("<h3>No data in the current session.</h3>");
    else {
      out.println("<h3>Data in the Current Session:</h3>");
      out.println("<p>" + attributes + "</p>");
      out.println("<h4>Total number in current session: " + total + "</h3>");
    }
  }

  private String getCompanyName() {
    ServletContext context = getServletContext();
    String attributeName = "companyName";
    return (String) context.getAttribute(attributeName);
  }

  private void sendGrandTotal(PrintWriter out) {
    ServletContext context = getServletContext();
    String attributeName = "grandTotal";
    String attributeValue = (String) context.getAttribute(attributeName);
    String total = "0";
    if (attributeValue != null)
      total = attributeValue;

    out.println("<h3>Grand Total: " + total + "</h3>");
  }

  private void renderForm(HttpServletResponse response, PrintWriter out)
      throws IOException, ServletException {
    out.println("<p>");
    out.print("<form action=\"index.html\""); // Go to form
    out.println("method=\"get\">");
    out.println("<input type=\"submit\" name=\"command\" value=\"Continue\"/>");
    out.println("</form>");
    out.println("</p>");
  }

  public void doGet(HttpServletRequest request, HttpServletResponse response)
      throws IOException, ServletException {
    doPost(request, response);
  }
}