import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class SearchEngineGUI extends HttpServlet {
  public void doGet(HttpServletRequest request,
                    HttpServletResponse response)
      throws ServletException, IOException {

    // Get the cookies.
    Cookie[] cookies = request.getCookies();

    // Create the form.
    response.setContentType("text/html");
    PrintWriter out = response.getWriter();
    out.println(
        "<html>\n" +
        "<head><title>Search Form</title></head>\n" +
        "<body>\n" +
            "<h1>Search Form</h1>\n");
    ServletUtil.echoCookiesInRequest(request, out);
    out.println("<form name=\"searchForm\"\n" +
                "action=\"/mySearchEngine/SearchHandler\"\n" +
                "method=\"post\"/>\n" +
                "<h2>Specify new keywords:</h2>\n" +
                "<p><input type=\"text\" name=\"searchCriteria\"/>"+
                "</p>\n" +
                "<p><input type=\"submit\" name=\"submitCmd\"" +
                     " value=\"Go get it!\"/>" +
                "</p>\n" +
            "</form>\n" +
            getPreviousSearchCriteria(cookies) +
       "</body>\n" +
       "</html>\n");
  }

  private String getPreviousSearchCriteria(Cookie[] cookies) {
    String cookieValue = "";
    if (cookies != null) {
      for(int i = 0; i < cookies.length; i++) {
        Cookie cookie      = cookies[i];
        String cookieName  = cookie.getName();
        if (cookieName.equals("previousSearchCriteria")) {
           cookieValue = cookie.getValue();
           break;
        }
      }
    }
    if (cookieValue.equals(""))
      return "<h3>No previous search.</h3>\n";
    else
      return "<h3>I know what you searched for last time: " +
              cookieValue + "</h3>\n";
  }
}