
import java.io.IOException;
import java.net.URLEncoder;

import javax.servlet.ServletException;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

public class SearchHandler extends HttpServlet {

  public void doGet(HttpServletRequest request, HttpServletResponse response)
      throws ServletException, IOException {

    // Read the form parameter.
    String searchCriteria = request.getParameter("searchCriteria");

    // Debugging info
    System.out.println("searchCriteria: " + searchCriteria);

    // Check if current search is valid.
    if ((searchCriteria == null) || (searchCriteria.length() == 0)) {
      response.sendError(HttpServletResponse.SC_NOT_FOUND, "Missing search string.");
      return;
    }

    // Create a new cookie for this search.
    Cookie previousSearchCookie = new Cookie("previousSearchCriteria",
        searchCriteria);

    // Add it to the response.
    response.addCookie(previousSearchCookie);

    // Set up the uri and redirect.
    String uri = "http://www.google.com/" + "search?q="
        + URLEncoder.encode(searchCriteria, "UTF8");
    response.sendRedirect(uri);
  }

  public void doPost(HttpServletRequest request, HttpServletResponse response)
      throws ServletException, IOException {
    doGet(request, response);
  }
}